<?php
include_once('./adodb/adodb.inc.php');

/*
function RowList($row)
{
     //print "count = ".count($row)."\n";
	     for ($k=0;$k<count($row);$k++) {
	            //if ($k==0) print "\n";
	            if ($k) {
					if ($k<(count($row)-1)) print "$row[$k], ";
					else print "$row[$k]";
				} else print "  $row[$k], ";
	     }
	     print "\n";
	     return ;
}
*/
///*
function RowList($row)
{
     //print "count = ".count($row)."\n";
     //$PHP_ver = (float) PHP_VERSION;

     //if ($PHP_ver>5.0) {
     if (is_array($row)) {
     	 // echo "row is array\n";
     	 if (count($row)==0) return;
	     for ($k=0;$k<count($row);$k++) {
	            //if ($k==0) print "\n";
	            if ($k) {
					if ($k<(count($row)-1)) print "$row[$k], ";
					else print "$row[$k]";
				} else print "  $row[$k], ";
	     }
	     print "\n";
	     return;
     } else {
     	 // echo "row is not array\n";
	     if(!is_array($row[0])) return;
	     //for ($k=0;$k<count($row);$k++) {
	            //if ($k==0) print "\n";
	            //if(!is_array($row[$k])) return false;
	             foreach ($row as $line) {
	             	for ($j=0;$j<count($line);$j++) {
			            if ($j) {
							if ($j<(count($line)-1)) print "$line[$j], ";
							else print "$line[$j]";
						} else print "  $line[$j], ";
					}
					print "\n";
				}
	     //}
	     return;
     }
     return;
}
//*/
/*
    Connect a new database
    $DBType="MySQL";      // DataBase Type
    $URL='10.5.200.1';
    $user='root';        // User Name
    $pw='taipower';      // Password
    $BataBase='RealTime_Test'; // Database containner name
    $SID='';         // SID, (for Oracle only)
*/
function NewDBConnect($DBType,$URL,$user,$pw,$BataBase,$SID="",$debug=false)
{
global $debug;

$db = &ADONewConnection($DBType);
if ($debug) $db->debug = 1;
else $db->debug = 0;
$db->Connect($URL,$user,$pw,$BataBase) || die("failed connection");
return $db;
}
/*
    List DataBase Tables and columns
*/
function ListDBTables($db, $Type=0)
{
// Dump Database Server Informations
$ServerInfo = $db->ServerInfo();
print ("Data Base Server Type: ".$db->databaseType."\n");
print ("Data Base version: ".$ServerInfo[version]."\n");

// List All Database Names
print ("All Database Names:\n");
$databases = $db->MetaDatabases('DatabaseName');
for ($i=0;$i<count($databases);$i++) {
    if ($i!=(count($databases)-1))
        print ($databases[$i].', ');
    else
        print ($databases[$i]);
}
print ("\n\n         Tables\n");

print ("============================\n");

// List Current Database columns
$Tables = $db->MetaTables('TABLES');
if (count($Tables)) {
            // loop for all tables
            for ($j=0;$j<count($Tables);$j++) {
                  print ("Table ".$j.":".$Tables[$j]."\n");
                  // list all columns
                  RowList($db->MetaColumnNames($Tables[$j],$numericIndex=true));
            }
}
print ("============================\n\n");
}


/*
    List DataBase Tables and columns
*/
function GetColNames($db, $DataBase)
{
	// List Current Database columns
	return $db->MetaColumnNames($DataBase,$numericIndex=true);
}


/*
    Get DataBase Table Fields
*/
function GetTableField($db, $DataBase)
{
	// Get Current Database fields
	//return $db->Execute("SHOW FIELDS FROM '$DataBase'");
	//return $db->GetAssoc("SHOW FIELDS FROM '$DataBase'");
	return $db->MetaColumns($DataBase);
}
/*
    Build DataBase Table Fields SQL
    Test the DataBase structure and build
    SQL command for this structure for D.B.
	create purpose.
*/
function BuildTableField($db, $DataBase)
{

	// Get Current Database fields
	$Fields = GetTableField($db, $DataBase);

	// Build SQL
	if (!$Fields) return null;
    $SQL = "CREATE TABLE `".$DataBase."` (\n";
    foreach ($Fields as $record) {
    	$SQL .= '`'.$record->name.'` ';	//.$record->type.' ';
    	switch ($record->type) {
    		case "I":
    			if ($record->max_length==2) {
					$SQL .= 'smallint';
					break;
				}
				if ($record->max_length==4) $SQL .= 'int';
    			else $SQL .= 'longint';
    			break;
    		case "C":
    			$SQL .= "varchar($record->max_length)";
    			break;

    			break;
    	}
    	if ( !empty($record->default) )
    		$SQL .= ' DEFAULT \''.$record['default'].'\'';
    	if ($record->not_null) $SQL .= ' NOT NULL';
    	if ( !empty($record->Extra) ) $SQL .= ' '.$record->Extra;
    	$SQL .= ",\n";
    }
    $SQL = @ereg_replace(",\n$", null, $SQL);

    // Save all Column Indexes
    $SQL .= $db->MetaPrimaryKeys($DataBase);
    $SQL .= ")";

    //Save table engine, 	Not Test Yet
    /*
    $records = $db->GetAssoc("SHOW TABLE STATUS LIKE '".$DataBase."'");
	// print "records = $records\n";
	if ($records) {
	    foreach ($records as $record) {
	    	if ( !empty($record['Engine']) )
	    		$SQL .= ' ENGINE='.$record['Engine'];
	    	if ( !empty($record['Auto_increment']) )
	    		$SQL .= ' AUTO_INCREMENT='.$record['Auto_increment'];
	    }
    }
    */
    return $SQL;
}
/*
      Getdata will get Database value and insert 0 in case of data values
      are absent.
      Parameters  Descriptions
      $db         Database connection
      $SQL        SQL command
      $Dtime      start Date and time format = 'YYYY-MM-DD HH:MM:SS'
      $Step       time interval(Min.) per data value, for data absent check.
      $NValue     Number of value per unit.

      First value must be Date/Time data, and rest is(are)
      data value(s).
*/
function Getdata($db, $SQL, $Dtime, $Step, $NValue)
{
$recordSet = $db->Execute($SQL);

if (!$recordSet) 	{
                print $db->ErrorMsg();
                return NULL;
} else {
      $debug = 0;

      /* Dump table contents */

      $dayx  = substr ($Dtime, 8,2);
      // $hourx = 0;
      $hourx = substr ($Dtime, 11,2);
      // _lIt$Step
      $minx = -$Step;
      if ($debug) print "Dayx = ".$dayx.", hourx = ".$hourx.", Minx = ".$minx."\n";
      while (!$recordSet->EOF) {
          $fld = $recordSet->FetchField(1);
      	  $type = $recordSet->MetaType($fld->type);

          /*
              Check Data loss or same
          */
          if ($debug) print $recordSet->fields[0]."\n";
          $dayy  = substr ($recordSet->fields[0],  8,2);
          $houry = substr ($recordSet->fields[0], 11,2);
          $miny  = substr ($recordSet->fields[0], 14,2);
         if ($debug) print "Dayy = ".$dayy.", houry = ".$houry.", Miny = ".$miny."\n";
          $diff = (int) (MinDiffX($dayx, $hourx, $minx, $dayy, $houry, $miny)/$Step+0.4);

          // Data loss
          if ($diff>1) {
                  $j=$diff-1;
                  if ($debug) {
                        print "======== Data Loss =============\n";
                        print ">>> ".$dayx.", ".$hourx.", ".$minx.", ".$dayy.", ".$houry.", ".$miny." <<<\n";
                        print "Total Insert Data Count = ".$j."\n";
                        print "================================\n";
                  }
                  //for ($i=$NValue;$i<=$diff;$i++) {
                  for ($i=1;$i<$diff;$i++) {
                        for ($j=0;$j<$NValue;$j++) $data[] = "0";
                        // $data[] = "0";
                        // $data[] = "0";
                        // $data[] = "\n";
                        if ($debug) print "  >> Insert loss.\n";
                  }
                  if ($debug) print "================================\n";
          }

          if ( $type == 'D' || $type == 'T'&& $diff>0)
             		  $data[] = $recordSet->fields[0].' '.$recordSet->UserDate($recordSet->fields[1],'m/d/Y')."\n";
       	  else {
          		    /* print '     '.$recordSet->fields[0].' '.$recordSet->fields[1]."\n"; */
          		    if ($diff) {
          		        $i = count($recordSet->fields);
                      for ($k=0;$k<$i;$k++) {
                               if ($recordSet->fields[$k] != "")
                                                $data[] = $recordSet->fields[$k];
                               // else $data[] = "0";
                      }
              		    // $data[] =  "\n";
          		    }
         }

          $dayx = $dayy;
          $hourx = $houry;
          $minx = $miny;

       	  $recordSet->MoveNext();
         }
          $db->close();

        }
        return $data;
}

?>

